! this program converts the list of durations in eighth notes of Terry Riley's In C into a list of probabilities, to be used as a Markov chain
implicit none
integer :: i
real :: x, y, p
open(unit=11,file="input.TXT") ! this file contains the durations of all 53 patterns of Terry Riley's  In C (1 unit = 1 eighth note)
open(unit=12,file="markovchain.TXT") ! output file containing the Markov chain values

do i=1,52
  read(11,*) X
  y = 280. * 0.5 / x ! tempo is 8 = 280, which means that 280 eighth notes are played every minute, and this value * 0.5 are present in 30 seconds (which is the wished duration for each pattern). Dividing it by the pattern duration gives us the wished number of repetitions (averagely).
  p = 1. / (y + 1.) ! i.e., out of y + 1 results, we expect y to be repetition of a pattern and 1 to be the next pattern
  write(12,"(F5.3)") p
enddo

p = 0. ! for the last pattern (53th), the probability of a next pattern is 0
write(12,"(F5.3)",advance="NO") p

end